diff --git a/include/wicked/bonding.h b/include/wicked/bonding.h
index a17434719..23b6a7709 100644
--- a/include/wicked/bonding.h
+++ b/include/wicked/bonding.h
@@ -1,11 +1,24 @@
 /*
- * Bonding support for netinfo
+ *	Bonding support for netinfo
  *
- * Copyright (C) 2009-2012 Olaf Kirch <okir@suse.de>
+ *	Copyright (C) 2009-2012 Olaf Kirch <okir@suse.de>
+ *	Copyright (C) 2009-2023 SUSE LLC
+ *
+ *	This program is free software; you can redistribute it and/or modify
+ *	it under the terms of the GNU General Public License as published by
+ *	the Free Software Foundation; either version 2 of the License, or
+ *	(at your option) any later version.
+ *
+ *	This program is distributed in the hope that it will be useful,
+ *	but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *	GNU General Public License for more details.
+ *
+ *	You should have received a copy of the GNU General Public License
+ *	along with this program. If not, see <http://www.gnu.org/licenses/>.
  */
-
-#ifndef __WICKED_BONDING_H__
-#define __WICKED_BONDING_H__
+#ifndef NI_WICKED_BONDING_H
+#define NI_WICKED_BONDING_H
 
 enum {
 	NI_BOND_MONITOR_MII = 1,
@@ -66,22 +79,27 @@ enum {
 };
 
 enum {
-	NI_BOND_SLAVE_STATE_ACTIVE = 0,
-	NI_BOND_SLAVE_STATE_BACKUP = 1,
+	NI_BOND_PORT_STATE_ACTIVE = 0,
+	NI_BOND_PORT_STATE_BACKUP = 1,
 };
 enum {
-	NI_BOND_SLAVE_LINK_UP = 0,
-	NI_BOND_SLAVE_LINK_FAIL = 1,
-	NI_BOND_SLAVE_LINK_DOWN = 2,
-	NI_BOND_SLAVE_LINK_BACK = 3,
+	NI_BOND_PORT_LINK_UP = 0,
+	NI_BOND_PORT_LINK_FAIL = 1,
+	NI_BOND_PORT_LINK_DOWN = 2,
+	NI_BOND_PORT_LINK_BACK = 3,
 };
 
-typedef struct ni_bonding_slave_array	ni_bonding_slave_array_t;
-typedef struct ni_bonding_slave		ni_bonding_slave_t;
-
-struct ni_bonding_slave_info {
-	unsigned int			refcount;
+/*
+ * Bonding port (link-request) configuration
+ */
+struct ni_bonding_port_config {
+	unsigned int			queue_id;
+};
 
+/*
+ * Bonding port interface info properties
+ */
+struct ni_bonding_port_info {
 	unsigned int			state;
 	unsigned int			mii_status;
 	ni_hwaddr_t			perm_hwaddr;
@@ -90,16 +108,6 @@ struct ni_bonding_slave_info {
 	unsigned int			link_failure_count;
 };
 
-struct ni_bonding_slave {
-	ni_netdev_ref_t			device;
-	ni_bonding_slave_info_t *	info;
-};
-
-struct ni_bonding_slave_array {
-	unsigned int			count;
-	ni_bonding_slave_t **		data;
-};
-
 struct ni_bonding {
 	unsigned int		mode;
 
@@ -143,82 +151,53 @@ struct ni_bonding {
 
 	ni_netdev_ref_t		primary_slave;
 	ni_netdev_ref_t		active_slave;
-
-	ni_bonding_slave_array_t slaves;
 };
 
-extern int		ni_bonding_load(const char *options);
-
-extern ni_bonding_t *	ni_bonding_new(void);
-extern ni_bonding_t *	ni_bonding_clone(const ni_bonding_t *);
-extern void		ni_bonding_free(ni_bonding_t *);
-
-extern void		ni_bonding_get_slave_names(const ni_bonding_t *, ni_string_array_t *);
-extern ni_bool_t	ni_bonding_has_slave(ni_bonding_t *, const char *);
-extern ni_bonding_slave_t * ni_bonding_add_slave(ni_bonding_t *, const char *);
-
-extern ni_bool_t	ni_bonding_set_option(ni_bonding_t *, const char *, const char *);
-extern int		ni_bonding_parse_sysfs_attrs(const char *, ni_bonding_t *);
-extern int		ni_bonding_write_sysfs_attrs(const char *ifname,
-						const ni_bonding_t *cfg_bond,
-						ni_bonding_t       *cur_bond,
-						ni_bool_t is_up, ni_bool_t has_slaves);
-
-extern ni_bool_t	ni_bonding_is_valid_arp_ip_target(const char *);
-
-extern const char *	ni_bonding_validate(const ni_bonding_t *bonding);
-
-extern const char *	ni_bonding_mode_type_to_name(unsigned int);
-extern int		ni_bonding_mode_name_to_type(const char *);
-
-extern const char *	ni_bonding_arp_validate_type_to_name(unsigned int);
-extern int		ni_bonding_arp_validate_name_to_type(const char *);
-
-extern const char *	ni_bonding_arp_validate_targets_to_name(unsigned int);
-extern int		ni_bonding_arp_validate_targets_to_type(const char *);
-
-extern const char *	ni_bonding_mii_carrier_detect_name(unsigned int);
-extern int		ni_bonding_mii_carrier_detect_type(const char *);
-
-extern const char *	ni_bonding_xmit_hash_policy_to_name(unsigned int);
-extern int		ni_bonding_xmit_hash_name_to_policy(const char *);
-
-extern const char *	ni_bonding_lacp_rate_name(unsigned int);
-extern int		ni_bonding_lacp_rate_mode(const char *);
-
-extern const char *	ni_bonding_ad_select_name(unsigned int);
-extern int		ni_bonding_ad_select_mode(const char *);
-
-extern const char *	ni_bonding_primary_reselect_name(unsigned int);
-extern int		ni_bonding_primary_reselect_mode(const char *);
-
-extern const char *	ni_bonding_fail_over_mac_name(unsigned int);
-extern int		ni_bonding_fail_over_mac_mode(const char *);
-
-extern const char *	ni_bonding_slave_state_name(unsigned int);
-extern const char *	ni_bonding_slave_mii_status_name(unsigned int);
-
-extern ni_bonding_slave_t *	ni_bonding_bind_slave(ni_bonding_t *, const ni_netdev_ref_t *, const char *);
-extern ni_bool_t		ni_bonding_unbind_slave(ni_bonding_t *, const ni_netdev_ref_t *, const char *);
-
-extern ni_bonding_slave_info_t *ni_bonding_slave_info_new(void);
-extern ni_bonding_slave_info_t *ni_bonding_slave_info_ref(ni_bonding_slave_info_t *);
-extern void			ni_bonding_slave_info_free(ni_bonding_slave_info_t *);
-extern void			ni_bonding_slave_info_reset(ni_bonding_slave_info_t *);
-
-extern ni_bonding_slave_t *	ni_bonding_slave_new(void);
-extern void			ni_bonding_slave_free(ni_bonding_slave_t *);
-extern void			ni_bonding_slave_set_info(ni_bonding_slave_t *, ni_bonding_slave_info_t *);
-extern ni_bonding_slave_info_t *ni_bonding_slave_get_info(ni_bonding_slave_t *);
-
-extern void			ni_bonding_slave_array_destroy(ni_bonding_slave_array_t *);
-extern ni_bool_t		ni_bonding_slave_array_append(ni_bonding_slave_array_t *, ni_bonding_slave_t *);
-extern ni_bool_t		ni_bonding_slave_array_delete(ni_bonding_slave_array_t *, unsigned int);
-extern ni_bonding_slave_t *	ni_bonding_slave_array_remove(ni_bonding_slave_array_t *, unsigned int);
-extern unsigned int		ni_bonding_slave_array_index_by_ifname(ni_bonding_slave_array_t *, const char *);
-extern unsigned int		ni_bonding_slave_array_index_by_ifindex(ni_bonding_slave_array_t *, unsigned int);
-extern ni_bonding_slave_t *	ni_bonding_slave_array_get(ni_bonding_slave_array_t *, unsigned int);
-extern ni_bonding_slave_t *	ni_bonding_slave_array_get_by_ifname(ni_bonding_slave_array_t *, const char *);
-extern ni_bonding_slave_t *	ni_bonding_slave_array_get_by_ifindex(ni_bonding_slave_array_t *, unsigned int);
-
-#endif /* __WICKED_BONDING_H__ */
+extern int				ni_bonding_load(const char *options);
+
+extern ni_bonding_t *			ni_bonding_new(void);
+extern ni_bonding_t *			ni_bonding_clone(const ni_bonding_t *);
+extern void				ni_bonding_free(ni_bonding_t *);
+
+extern const char *			ni_bonding_validate(const ni_bonding_t *bonding);
+extern ni_bool_t			ni_bonding_is_valid_arp_ip_target(const char *);
+
+extern ni_bool_t			ni_bonding_set_option(ni_bonding_t *,
+							const char *, const char *);
+extern int				ni_bonding_parse_sysfs_attrs(const char *,
+							ni_bonding_t *);
+extern int				ni_bonding_write_sysfs_attrs(const char *,
+							const ni_bonding_t *cfg_bond,
+							ni_bonding_t       *cur_bond,
+							ni_bool_t up, ni_bool_t ports);
+
+extern const char *			ni_bonding_mode_type_to_name(unsigned int);
+extern int				ni_bonding_mode_name_to_type(const char *);
+extern const char *			ni_bonding_arp_validate_type_to_name(unsigned int);
+extern int				ni_bonding_arp_validate_name_to_type(const char *);
+extern const char *			ni_bonding_arp_validate_targets_to_name(unsigned int);
+extern int				ni_bonding_arp_validate_targets_to_type(const char *);
+extern const char *			ni_bonding_mii_carrier_detect_name(unsigned int);
+extern int				ni_bonding_mii_carrier_detect_type(const char *);
+extern const char *			ni_bonding_xmit_hash_policy_to_name(unsigned int);
+extern int				ni_bonding_xmit_hash_name_to_policy(const char *);
+extern const char *			ni_bonding_lacp_rate_name(unsigned int);
+extern int				ni_bonding_lacp_rate_mode(const char *);
+extern const char *			ni_bonding_ad_select_name(unsigned int);
+extern int				ni_bonding_ad_select_mode(const char *);
+extern const char *			ni_bonding_primary_reselect_name(unsigned int);
+extern int				ni_bonding_primary_reselect_mode(const char *);
+extern const char *			ni_bonding_fail_over_mac_name(unsigned int);
+extern int				ni_bonding_fail_over_mac_mode(const char *);
+
+extern ni_bonding_port_config_t *	ni_bonding_port_config_new(void);
+extern void				ni_bonding_port_config_free(ni_bonding_port_config_t *);
+
+extern ni_bonding_port_info_t *		ni_bonding_port_info_new(void);
+extern void				ni_bonding_port_info_free(ni_bonding_port_info_t *);
+extern void				ni_bonding_port_info_reset(ni_bonding_port_info_t *);
+
+extern const char *			ni_bonding_port_state_name(unsigned int);
+extern const char *			ni_bonding_port_mii_status_name(unsigned int);
+
+#endif /* NI_WICKED_BONDING_H */
diff --git a/include/wicked/bridge.h b/include/wicked/bridge.h
index 9332edfa7..86ff0c927 100644
--- a/include/wicked/bridge.h
+++ b/include/wicked/bridge.h
@@ -1,28 +1,47 @@
 /*
- * bridge definitions for netinfo
+ *	bridge definitions for netinfo
  *
- * Copyright (C) 2009-2012 Olaf Kirch <okir@suse.de>
+ *	Copyright (C) 2009-2012 Olaf Kirch <okir@suse.de>
+ *	Copyright (C) 2012-2023 SUSE LLC
+ *
+ *	This program is free software; you can redistribute it and/or modify
+ *	it under the terms of the GNU General Public License as published by
+ *	the Free Software Foundation; either version 2 of the License, or
+ *	(at your option) any later version.
+ *
+ *	This program is distributed in the hope that it will be useful,
+ *	but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *	GNU General Public License for more details.
+ *
+ *	You should have received a copy of the GNU General Public License
+ *	along with this program. If not, see <http://www.gnu.org/licenses/>.
  */
+#ifndef NI_WICKED_BRIDGE_H
+#define NI_WICKED_BRIDGE_H
 
-#ifndef __WICKED_BRIDGE_H__
-#define __WICKED_BRIDGE_H__
 
 #define NI_BRIDGE_VALUE_NOT_SET			-1U
 
-typedef enum ni_bridge_stp {
-	NI_BRIDGE_NO_STP = 0,			/* no spanning tree    */
-	NI_BRIDGE_KERN_STP,			/* STP in the kernel   */
-	NI_BRIDGE_USER_STP,			/* (R)STP in userspace */
-} ni_bridge_stp_t;
-
-typedef struct ni_bridge_port_status {
+/*
+ * Bridge port (link-request) configuration
+ */
+struct ni_bridge_port_config {
 	unsigned int		priority;
 	unsigned int		path_cost;
+};
 
-	int			state;
+/*
+ * Bridge port interface info properties
+ */
+struct ni_bridge_port_info {
+	unsigned int		state;
 	unsigned int		port_id;
 	unsigned int		port_no;
 
+	unsigned int		priority;
+	unsigned int		path_cost;
+
 	char *			designated_root;
 	char *			designated_bridge;
 
@@ -36,22 +55,13 @@ typedef struct ni_bridge_port_status {
 	unsigned long		hold_timer;
 	unsigned long		message_age_timer;
 	unsigned long		forward_delay_timer;
-} ni_bridge_port_status_t;
-
-struct ni_bridge_port {
-	char *			ifname;
-	unsigned int		ifindex;
-
-	unsigned int		priority;
-	unsigned int		path_cost;
-
-	ni_bridge_port_status_t	status;
 };
 
-typedef struct ni_bridge_port_array {
-	unsigned int		count;
-	ni_bridge_port_t **	data;
-} ni_bridge_port_array_t;
+typedef enum ni_bridge_stp {
+	NI_BRIDGE_NO_STP = 0,			/* no spanning tree    */
+	NI_BRIDGE_KERN_STP,			/* STP in the kernel   */
+	NI_BRIDGE_USER_STP,			/* (R)STP in userspace */
+} ni_bridge_stp_t;
 
 typedef struct ni_bridge_status {
 	unsigned int		stp_state;
@@ -79,29 +89,24 @@ struct ni_bridge {
 	double			max_age;
 
 	ni_bridge_status_t	status;
-	ni_bridge_port_array_t	ports;
 };
 
-extern ni_bridge_t *	ni_bridge_new(void);
-extern void		ni_bridge_free(ni_bridge_t *);
-extern void		ni_bridge_ports_destroy(ni_bridge_t *);
-extern void		ni_bridge_status_destroy(ni_bridge_status_t *);
-extern void		ni_bridge_port_status_destroy(ni_bridge_port_status_t *);
-extern int		ni_bridge_add_port(ni_bridge_t *, ni_bridge_port_t *);
-extern int		ni_bridge_del_port(ni_bridge_t *, unsigned int);
-extern int		ni_bridge_del_port_ifname(ni_bridge_t *, const char *);
-extern int		ni_bridge_del_port_ifindex(ni_bridge_t *, unsigned int);
-extern void		ni_bridge_get_port_names(const ni_bridge_t *, ni_string_array_t *);
-
-extern ni_bridge_port_t *ni_bridge_port_new(ni_bridge_t *br, const char *ifname, unsigned int ifindex);
-extern ni_bridge_port_t *ni_bridge_port_by_index(const ni_bridge_t *br, unsigned int ifindex);
-extern ni_bridge_port_t *ni_bridge_port_by_name(const ni_bridge_t *br, const char *ifname);
-extern ni_bridge_port_t *ni_bridge_port_clone(const ni_bridge_port_t *port);
-extern void		ni_bridge_port_free(ni_bridge_port_t *port);
-
-
-extern const char *	ni_bridge_port_validate(const ni_bridge_port_t *);
-extern const char *	ni_bridge_validate(const ni_bridge_t *);
-extern unsigned int	ni_bridge_waittime_from_xml(const xml_node_t *brnode);
-
-#endif /* __WICKED_BRIDGE_H__ */
+extern ni_bridge_t *			ni_bridge_new(void);
+extern void				ni_bridge_free(ni_bridge_t *);
+extern void				ni_bridge_status_destroy(ni_bridge_status_t *);
+
+extern unsigned int			ni_bridge_waittime_from_xml(const xml_node_t *brnode);
+
+extern const char *			ni_bridge_port_priority_validate(unsigned int);
+extern const char *			ni_bridge_port_path_cost_validate(unsigned int);
+extern const char *			ni_bridge_validate(const ni_bridge_t *);
+
+extern ni_bridge_port_config_t *	ni_bridge_port_config_new(void);
+extern void				ni_bridge_port_config_free(ni_bridge_port_config_t *);
+
+extern ni_bridge_port_info_t *		ni_bridge_port_info_new(void);
+extern void				ni_bridge_port_info_free(ni_bridge_port_info_t *);
+
+extern const char *			ni_bridge_port_state_name(unsigned int);
+
+#endif /* NI_WICKED_BRIDGE_H */
diff --git a/include/wicked/dbus.h b/include/wicked/dbus.h
index 6c18bec1b..887c69998 100644
--- a/include/wicked/dbus.h
+++ b/include/wicked/dbus.h
@@ -424,6 +424,23 @@ typedef struct ni_dbus_xml_validate_context {
 	void *			user_data;
 } ni_dbus_xml_validate_context_t;
 
+typedef struct ni_dbus_xml_traverse_path	ni_dbus_xml_traverse_path_t;
+typedef struct ni_dbus_xml_traverse_context	ni_dbus_xml_traverse_context_t;
+typedef dbus_bool_t				ni_dbus_xml_traverse_process_fn_t(
+								const ni_xs_type_t *, const char *,
+								const ni_dbus_xml_traverse_path_t *,
+								ni_dbus_xml_traverse_context_t *);
+
+struct ni_dbus_xml_traverse_path {
+	const ni_dbus_xml_traverse_path_t *	prev;
+	const ni_xs_type_t *			type;
+	const char *				name;
+};
+
+struct ni_dbus_xml_traverse_context {
+	ni_dbus_xml_traverse_process_fn_t *	process;
+};
+
 extern ni_xs_scope_t *		ni_dbus_xml_init(void);
 extern int			ni_dbus_xml_register_services(ni_xs_scope_t *);
 extern unsigned int		ni_dbus_xml_method_num_args(const ni_dbus_method_t *);
@@ -434,6 +451,9 @@ extern int			ni_dbus_xml_map_method_argument(const ni_dbus_method_t *method, uns
 						xml_node_t *doc_node, xml_node_t **ret_node, ni_bool_t *skip_call);
 extern dbus_bool_t		ni_dbus_xml_validate_argument(const ni_dbus_method_t *, unsigned int,
 						xml_node_t *, const ni_dbus_xml_validate_context_t *);
+extern dbus_bool_t		ni_dbus_xml_traverse_service_properties(const ni_dbus_service_t *,
+						ni_dbus_xml_traverse_context_t *);
+extern const char *		ni_dbus_xml_traverse_path_print(ni_stringbuf_t *, const ni_dbus_xml_traverse_path_t *);
 extern dbus_bool_t		ni_dbus_xml_serialize_arg(const ni_dbus_method_t *, unsigned int,
 						ni_dbus_variant_t *, xml_node_t *);
 extern dbus_bool_t		ni_dbus_xml_method_has_return(const ni_dbus_method_t *);
diff --git a/include/wicked/fsm.h b/include/wicked/fsm.h
index 4bf53c80e..c047c1c64 100644
--- a/include/wicked/fsm.h
+++ b/include/wicked/fsm.h
@@ -285,6 +285,7 @@ typedef struct ni_ifmatcher {
 				allow_persistent   : 1,
 				ignore_startmode   : 1,
 				skip_active        : 1,
+				ifreload           : 1,
 				ifdown             : 1;
 } ni_ifmatcher_t;
 
@@ -342,8 +343,10 @@ extern unsigned int		ni_fsm_get_matching_workers(ni_fsm_t *, ni_ifmatcher_t *, n
 extern unsigned int		ni_fsm_mark_matching_workers(ni_fsm_t *, ni_ifworker_array_t *, const ni_ifmarker_t *);
 extern unsigned int		ni_fsm_start_matching_workers(ni_fsm_t *, ni_ifworker_array_t *);
 extern void			ni_fsm_reset_matching_workers(ni_fsm_t *, ni_ifworker_array_t *, const ni_uint_range_t *, ni_bool_t);
-extern void			ni_fsm_print_config_hierarchy(const ni_fsm_t *);
-extern void			ni_fsm_print_system_hierarchy(const ni_fsm_t *);
+extern void			ni_fsm_print_config_hierarchy(const ni_fsm_t *,
+						const ni_ifworker_array_t *, ni_log_fn_t *);
+extern void			ni_fsm_print_system_hierarchy(const ni_fsm_t *,
+						const ni_ifworker_array_t *, ni_log_fn_t *);
 extern int			ni_fsm_build_hierarchy(ni_fsm_t *, ni_bool_t);
 extern ni_ifworker_t *		ni_fsm_worker_identify(ni_fsm_t *, const xml_node_t *, const char *,
 							ni_ifworker_type_t *, const char **);
diff --git a/include/wicked/logging.h b/include/wicked/logging.h
index 7d2fbd896..f9a65fdaf 100644
--- a/include/wicked/logging.h
+++ b/include/wicked/logging.h
@@ -17,6 +17,8 @@
 # define __noreturn	/* */
 #endif
 
+typedef void		ni_log_fn_t(const char *, ...);
+
 extern void		ni_info(const char *, ...) __fmtattr;
 extern void		ni_note(const char *, ...) __fmtattr;
 extern void		ni_warn(const char *, ...) __fmtattr;
diff --git a/include/wicked/netinfo.h b/include/wicked/netinfo.h
index 9f7e91539..ce0170587 100644
--- a/include/wicked/netinfo.h
+++ b/include/wicked/netinfo.h
@@ -14,19 +14,22 @@
 
 #include "client/client_state.h"
 
-typedef struct ni_link_stats	ni_link_stats_t;
+typedef struct ni_netdev_port_info	ni_netdev_port_info_t;
 
-typedef struct ni_slaveinfo	ni_slaveinfo_t;
-struct ni_slaveinfo {
-	ni_iftype_t		type;
-	char *			kind;
+struct ni_netdev_port_info {
+	ni_iftype_t			type;
+	char *				kind;
 
 	union {
-	    ni_bonding_slave_info_t *	bond;
+		ni_bonding_port_info_t *	bond;
+		ni_team_port_info_t *		team;
+		ni_bridge_port_info_t *		bridge;
+		ni_ovs_bridge_port_info_t *	ovsbr;
 	};
 };
 
 typedef struct ni_linkinfo ni_linkinfo_t;
+
 struct ni_linkinfo {
 	ni_iftype_t		type;
 	unsigned int		ifindex;
@@ -40,14 +43,12 @@ struct ni_linkinfo {
 	unsigned int		txqlen;
 	ni_netdev_ref_t		lowerdev;
 	ni_netdev_ref_t		masterdev;
-	ni_slaveinfo_t		slave;
+	ni_netdev_port_info_t	port;
 	unsigned int		oper_state;
 	char *			qdisc;
 	char *			kind;
 
 	unsigned int		saved_mtu;
-
-	ni_link_stats_t *	stats;
 };
 
 struct ni_netdev {
@@ -101,7 +102,25 @@ struct ni_netdev {
 	ni_event_filter_t *	event_filter;
 };
 
-typedef struct ni_netdev_port_req	ni_netdev_port_req_t;
+/*
+ * netdev link-request port config
+ */
+typedef struct ni_netdev_port_config	ni_netdev_port_config_t;
+
+struct ni_netdev_port_config {
+	ni_iftype_t			type;
+
+	union {
+		ni_bonding_port_config_t *	bond;
+		ni_team_port_config_t *		team;
+		ni_bridge_port_config_t *	bridge;
+		ni_ovs_bridge_port_config_t *	ovsbr;
+	};
+};
+
+/*
+ * netdev link-request configuration
+ */
 struct ni_netdev_req {
 	unsigned int		ifflags;
 
@@ -112,7 +131,7 @@ struct ni_netdev_req {
 	char *			alias;
 
 	ni_netdev_ref_t		master;
-	ni_netdev_port_req_t *	port;
+	ni_netdev_port_config_t port;
 };
 
 extern ni_bool_t	ni_set_global_config_path(const char *);
@@ -171,6 +190,7 @@ extern ni_netconfig_t *	ni_global_state_handle(int);
 extern ni_netdev_t *	ni_netdev_by_name(ni_netconfig_t *nic, const char *name);
 extern ni_netdev_t *	ni_netdev_by_index(ni_netconfig_t *nic, unsigned int index);
 extern ni_netdev_t *	ni_netdev_by_hwaddr(ni_netconfig_t *nic, const ni_hwaddr_t *lla);
+extern ni_netdev_t *	ni_netdev_by_iftype(ni_netconfig_t *nic, ni_iftype_t);
 extern ni_netdev_t *	ni_netdev_by_vlan_name_and_tag(ni_netconfig_t *nc,
 				const char *physdev, uint16_t tag);
 extern unsigned int	ni_netdev_name_to_index(const char *);
@@ -219,7 +239,6 @@ extern void		ni_netdev_set_ovs_bridge(ni_netdev_t *, ni_ovs_bridge_t *);
 extern void		ni_netdev_set_ethtool(ni_netdev_t *, ni_ethtool_t *);
 extern void		ni_netdev_set_ethernet(ni_netdev_t *, ni_ethernet_t *);
 extern void		ni_netdev_set_infiniband(ni_netdev_t *, ni_infiniband_t *);
-extern void		ni_netdev_set_link_stats(ni_netdev_t *, ni_link_stats_t *);
 extern void		ni_netdev_set_wireless(ni_netdev_t *, ni_wireless_t *);
 extern void		ni_netdev_set_openvpn(ni_netdev_t *, ni_openvpn_t *);
 extern void		ni_netdev_set_tuntap(ni_netdev_t *, ni_tuntap_t *);
@@ -240,7 +259,6 @@ extern ni_bool_t	ni_netdev_supports_arp(ni_netdev_t *);
 extern void             ni_netdev_clear_addresses(ni_netdev_t *);
 extern void             ni_netdev_clear_routes(ni_netdev_t *);
 extern void		ni_netdev_clear_event_filters(ni_netdev_t *);
-extern void		ni_netdev_slaveinfo_destroy(ni_slaveinfo_t *);
 
 extern const ni_uuid_t *ni_netdev_add_event_filter(ni_netdev_t *, unsigned int mask);
 extern const ni_uuid_t *ni_netdev_get_event_uuid(ni_netdev_t *, ni_event_t);
@@ -302,8 +320,6 @@ extern ni_bool_t	ni_netdev_device_is_ready(ni_netdev_t *);
 extern ni_bool_t	ni_netdev_device_always_ready(ni_netdev_t *);
 extern ni_bool_t	ni_netdev_link_always_ready(ni_linkinfo_t *);
 
-extern ni_tristate_t	ni_netdev_guess_link_required(const ni_netdev_t *);
-
 static inline int
 ni_netdev_device_is_up(const ni_netdev_t *dev)
 {
@@ -322,4 +338,18 @@ ni_netdev_network_is_up(const ni_netdev_t *dev)
 	return dev ? dev->link.ifflags & NI_IFF_NETWORK_UP : 0;
 }
 
+extern ni_bool_t		ni_netdev_port_info_data_init(ni_netdev_port_info_t *, ni_iftype_t);
+extern void			ni_netdev_port_info_data_destroy(ni_netdev_port_info_t *);
+extern ni_bool_t		ni_netdev_port_info_init(ni_netdev_port_info_t *, const char *);
+extern void			ni_netdev_port_info_destroy(ni_netdev_port_info_t *);
+
+extern ni_bool_t		ni_netdev_port_config_init(ni_netdev_port_config_t *, ni_iftype_t);
+extern void			ni_netdev_port_config_destroy(ni_netdev_port_config_t *);
+
+extern unsigned int		ni_netdev_get_ports(const ni_netdev_t *, ni_netdev_ref_array_t *,
+						ni_netconfig_t *);
+
+extern const ni_netdev_ref_t *	ni_netdev_get_master_ref(const ni_netdev_t *);
+extern ni_netdev_t *		ni_netdev_resolve_master(const ni_netdev_t *, ni_netconfig_t *);
+
 #endif /* NI_WICKED_NETINFO_H */
diff --git a/include/wicked/objectmodel.h b/include/wicked/objectmodel.h
index 908d7ac48..569eacfb1 100644
--- a/include/wicked/objectmodel.h
+++ b/include/wicked/objectmodel.h
@@ -35,6 +35,8 @@ extern void			ni_objectmodel_register_service(const ni_dbus_service_t *);
 extern void			ni_objectmodel_register_class(const ni_dbus_class_t *);
 extern const ni_dbus_class_t *	ni_objectmodel_get_class(const char *);
 extern ni_dbus_class_t *	ni_objectmodel_class_new(const char *, const ni_dbus_class_t *);
+extern unsigned int		ni_objectmodel_class_registry_count(void);
+extern unsigned int		ni_objectmodel_service_registry_count(void);
 
 #define NI_OBJECTMODEL_NETIF_CLASS		"netif"
 #define NI_OBJECTMODEL_NETIF_LIST_CLASS		"netif-list"
diff --git a/include/wicked/ovs.h b/include/wicked/ovs.h
index 6329ad97d..a4a8ca829 100644
--- a/include/wicked/ovs.h
+++ b/include/wicked/ovs.h
@@ -1,7 +1,7 @@
 /*
  *	OVS (bridge) device support
  *
- *	Copyright (C) 2015 SUSE Linux GmbH, Nuernberg, Germany.
+ *	Copyright (C) 2015-2023 SUSE LLC
  *
  *	This program is free software; you can redistribute it and/or modify
  *	it under the terms of the GNU General Public License as published by
@@ -13,13 +13,8 @@
  *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *	GNU General Public License for more details.
  *
- *	You should have received a copy of the GNU General Public License along
- *	with this program; if not, see <http://www.gnu.org/licenses/> or write
- *	to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
- *	Boston, MA 02110-1301 USA.
- *
- *	Authors:
- *		Marius Tomaschewski <mt@suse.de>
+ *	You should have received a copy of the GNU General Public License
+ *	along with this program. If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef NI_WICKED_OVS_H
 #define NI_WICKED_OVS_H
@@ -33,19 +28,16 @@ typedef struct ni_ovs_bridge_port	ni_ovs_bridge_port_t;
  * ovs bridge port config
  */
 struct ni_ovs_bridge_port_config {
-	ni_netdev_ref_t			bridge;
+	ni_var_array_t			args;
 };
 
 /*
- * ovs bridge port
+ * OVS Bridge port interface info properties
  */
-struct ni_ovs_bridge_port {
-	ni_netdev_ref_t			device;
+struct ni_ovs_bridge_port_info {
+	ni_netdev_ref_t			bridge;
 };
 
-ni_declare_ptr_array_type(ni_ovs_bridge_port);
-
-
 /*
  * ovs bridge config
  */
@@ -61,26 +53,20 @@ struct ni_ovs_bridge_config {
  */
 struct ni_ovs_bridge {
 	ni_ovs_bridge_config_t		config;
-	ni_ovs_bridge_port_array_t	ports;
 };
 
 
-extern ni_ovs_bridge_t *	ni_ovs_bridge_new(void);
-extern void			ni_ovs_bridge_free(ni_ovs_bridge_t *);
-extern void			ni_ovs_bridge_config_init(ni_ovs_bridge_config_t *);
-extern void			ni_ovs_bridge_config_destroy(ni_ovs_bridge_config_t *);
-
-extern ni_ovs_bridge_port_t *	ni_ovs_bridge_port_new(void);
-extern void			ni_ovs_bridge_port_free(ni_ovs_bridge_port_t *);
+extern ni_ovs_bridge_t *		ni_ovs_bridge_new(void);
+extern void				ni_ovs_bridge_free(ni_ovs_bridge_t *);
+extern void				ni_ovs_bridge_config_init(ni_ovs_bridge_config_t *);
+extern void				ni_ovs_bridge_config_destroy(ni_ovs_bridge_config_t *);
 
-extern				ni_declare_ptr_array_init(ni_ovs_bridge_port);
-extern				ni_declare_ptr_array_destroy(ni_ovs_bridge_port);
-extern				ni_declare_ptr_array_append(ni_ovs_bridge_port);
-extern				ni_declare_ptr_array_delete_at(ni_ovs_bridge_port);
-extern ni_ovs_bridge_port_t *	ni_ovs_bridge_port_array_add_new(ni_ovs_bridge_port_array_t *, const char *);
-extern ni_ovs_bridge_port_t *	ni_ovs_bridge_port_array_find_by_name(ni_ovs_bridge_port_array_t *, const char *);
+extern ni_ovs_bridge_port_config_t *	ni_ovs_bridge_port_config_new(void);
+extern ni_bool_t			ni_ovs_bridge_port_config_init(ni_ovs_bridge_port_config_t *);
+extern void				ni_ovs_bridge_port_config_destroy(ni_ovs_bridge_port_config_t *);
+extern void				ni_ovs_bridge_port_config_free(ni_ovs_bridge_port_config_t *);
 
-extern void			ni_ovs_bridge_port_config_init(ni_ovs_bridge_port_config_t *);
-extern void			ni_ovs_bridge_port_config_destroy(ni_ovs_bridge_port_config_t *);
+extern ni_ovs_bridge_port_info_t *	ni_ovs_bridge_port_info_new(void);
+extern void				ni_ovs_bridge_port_info_free(ni_ovs_bridge_port_info_t *);
 
 #endif /* NI_WICKED_OVS_H */
diff --git a/include/wicked/sysconfig.h b/include/wicked/sysconfig.h
index 5e865a14d..ed059576a 100644
--- a/include/wicked/sysconfig.h
+++ b/include/wicked/sysconfig.h
@@ -18,7 +18,7 @@ struct ni_sysconfig {
 extern int		ni_sysconfig_scandir(const char *, const char *,
 				struct ni_string_array *nsa);
 extern ni_sysconfig_t *	ni_sysconfig_new(const char *pathname);
-extern void		ni_sysconfig_destroy(ni_sysconfig_t *);
+extern void		ni_sysconfig_free(ni_sysconfig_t *);
 extern ni_sysconfig_t *	ni_sysconfig_read(const char *);
 extern ni_sysconfig_t *	ni_sysconfig_read_matching(const char *filename, const char **varnames);
 extern ni_sysconfig_t *	ni_sysconfig_merge_defaults(const ni_sysconfig_t *, const ni_sysconfig_t *);
@@ -26,9 +26,9 @@ extern ni_sysconfig_t *	ni_sysconfig_merge_defaults(const ni_sysconfig_t *, cons
 extern int		ni_sysconfig_overwrite(ni_sysconfig_t *);
 extern int		ni_sysconfig_rewrite(ni_sysconfig_t *);
 
-extern void		ni_sysconfig_set(ni_sysconfig_t *, const char *name, const char *variable);
-extern void		ni_sysconfig_set_integer(ni_sysconfig_t *, const char *name, unsigned int);
-extern void		ni_sysconfig_set_boolean(ni_sysconfig_t *, const char *name, int);
+extern ni_bool_t	ni_sysconfig_set(ni_sysconfig_t *, const char *name, const char *variable);
+extern ni_bool_t	ni_sysconfig_set_integer(ni_sysconfig_t *, const char *name, unsigned int);
+extern ni_bool_t	ni_sysconfig_set_boolean(ni_sysconfig_t *, const char *name, int);
 
 extern ni_var_t *	ni_sysconfig_get(const ni_sysconfig_t *, const char *name);
 extern const char *	ni_sysconfig_get_value(const ni_sysconfig_t *, const char *);
@@ -40,7 +40,7 @@ extern ni_bool_t	ni_sysconfig_get_integer_optional(const ni_sysconfig_t *, const
 extern ni_bool_t	ni_sysconfig_get_boolean_optional(const ni_sysconfig_t *, const char *, ni_bool_t *);
 extern ni_bool_t	ni_sysconfig_test_boolean(const ni_sysconfig_t *, const char *);
 
-extern int		ni_sysconfig_find_matching(const ni_sysconfig_t *, const char *,
+extern unsigned int	ni_sysconfig_find_matching(const ni_sysconfig_t *, const char *,
 				struct ni_string_array *);
 
 
diff --git a/include/wicked/system.h b/include/wicked/system.h
index 55c2bee12..c0a3a40c7 100644
--- a/include/wicked/system.h
+++ b/include/wicked/system.h
@@ -55,9 +55,6 @@ extern int		ni_system_bridge_create(ni_netconfig_t *, const char *,
 				const ni_bridge_t *, ni_netdev_t **);
 extern int		ni_system_bridge_setup(ni_netconfig_t *, ni_netdev_t *,
 				const ni_bridge_t *);
-extern int		ni_system_bridge_add_port(ni_netconfig_t *, ni_netdev_t *,
-				const ni_bridge_port_t *);
-extern int		ni_system_bridge_remove_port(ni_netdev_t *, unsigned int);
 extern int		ni_system_bridge_shutdown(ni_netdev_t *);
 extern int		ni_system_bridge_delete(ni_netconfig_t *, ni_netdev_t *);
 extern int		ni_system_ovs_bridge_create(ni_netconfig_t *nc,
